unit UnExport;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls,
  HREFparser,IEShapes,UnParserShapes;

Const
expHTML =
'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'+#13#10+
'<HTML><HEAD><TITLE>HREFparser '+IEDVersion+' export demo</TITLE>'+#13#10+
'<META content="HREFparser demo, IED Internet editing components" name=KeyWords>'+#13#10+
'<META content="Sergey Kanenko" name=Author>'+#13#10+
'<META content=all name=Robots>'+#13#10+
'</HEAD>'+#13#10+
'<body MARGINWIDTH="0" MARGINHEIGHT="0" bgColor=#FFFFFF>'+#13#10+
'<IMG SRC="%s" USEMAP="#HREFparserSiteMap" border=0>'+#13#10+
'<MAP NAME="HREFparserSiteMap">%s</MAP>'+#13#10+
'</body></html>';

expMapItem = '<AREA SHAPE="RECT" HREF="%s" ALT="%s" TITLE="%s" COORDS="%d,%d,%d,%d">';

type
  TfrmExport = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edWidth: TEdit;
    udWidth: TUpDown;
    Label2: TLabel;
    edHeight: TEdit;
    udHeight: TUpDown;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    BitMap : TBitmap;
  public
    { Public declarations }
    function CreateNewMap: TBitMap;
    procedure ExportToHTML(Diagram: TScrollBox; FileName: string; Scale:double);
  end;

var
  frmExport: TfrmExport;

implementation

{$R *.dfm}

{ TfrmExport }

function TfrmExport.CreateNewMap: TBitMap;
begin
  BitMap.Dormant;
  BitMap.Width  := udWidth.Position;
  BitMap.Height := udHeight.Position;
  result:= BitMap;
end;

procedure TfrmExport.ExportToHTML(Diagram: TScrollBox; FileName: string; Scale:double);
var
 i : integer;
 FS : TFileStream;
 BMPname : String;
 Content : string;
 s : string;
begin
 BMPname:=ChangeFileExt(FileName,'.bmp');
 BitMap.SaveToFile(BMPname);
 Content := '';
 for i:=0 to Diagram.ControlCount-1 do
  if Diagram.Controls[i] is TIEParserShape then
   with TIEParserShape(Diagram.Controls[i]) do
    begin
     if ShapeCaption<>nil then
       s:= ShapeCaption.Text
     else
       s:='';
     Content := Content+ Format(expMapItem,[HREFdoc.HREFSelf.HREF,
                                            s,
                                            s,
                                            Trunc(BoundsRect.Left*scale),
                                            Trunc(BoundsRect.Top*scale),
                                            Trunc(BoundsRect.Right*scale),
                                            Trunc(BoundsRect.Bottom*scale)])+#13#10;
    end;

 FS := TFileStream.Create(FileName,fmCreate);
 try
  content := Format(expHTML,[BMPname,content]);
  FS.Write(PChar(content)^,Length(content));
 finally
  FS.Free;
 end;
end;

procedure TfrmExport.FormCreate(Sender: TObject);
begin
 BitMap := TBitmap.Create;
end;

procedure TfrmExport.FormDestroy(Sender: TObject);
begin
 BitMap.Free;
end;

end.
